////////////////////////////////////////////////////////////////////////////////
//
//    SORTEADOR PSEUDO-ALEATRIO PARA USO RECREATIVO
//    DE 1-90 (USO EM 'TOMBOLA') OU 1-75 (USO EM 'BINGO')
//
//    AUTOR: CLAUDIO LRIOS    29/11/2013
//
//    USANDO MICROCONTROLADOR 16F628A E LCD 16X2
//    OBS. USO DIDTICO APENAS.
//
////////////////////////////////////////////////////////////////////////////////

//DEFINIES DO USURIO
//Descomente apenas uma opo e mantenha a outra comentada com '//'.

//    #DEFINE  BINGO
     #DEFINE  TOMBOLA

////////////////////////////////////////////////////////////////////////////////
//==============================================================================


#include <16F628A.h>
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOPUT, NOPROTECT, BROWNOUT, MCLR, NOLVP, NOCPD

#ignore_warnings 203   //desconsidera mensagem de 'condition always true'

#fuses INTRC_IO,NOWDT,NOPROTECT, MCLR ,BROWNOUT, PUT, NOLVP  // palavra  configurao
#use delay (clock=4000000)  // clock para 4 mhz



#include <LCD.C>

//macros
#define  linha1      lcd_gotoxy( 1, 1);     //vai para linha 1
#define  linha2      lcd_gotoxy( 1, 2);     //vai para linha 2
#define  limpa_lcd   lcd_send_byte(0,1);    //limpa tela do lcd
#define  pos_ap      lcd_gotoxy( 11, 1);    //vai para linha 1
#define  pos_ns      lcd_gotoxy( 1, 2);     //vai para linha 1
#define  pos_nf      lcd_gotoxy( 9, 2);     //vai para linha 1
#byte    portA    =  0x05
#define  bot         PIN_A2
//mensagens

#ifdef BINGO
byte const mens_1[] ={"BINGO ELETRONICO@"};
byte const vcomp =75;
byte const vcont1= 1;
byte const vcont2= 75;
#define tdado_msb  Tdado[9],3  //msb
#endif

#ifdef TOMBOLA
byte const mens_1[] ={"TOMBOLA ELETRON.@"};
byte const vcomp =90;
byte const vcont1 =1;
byte const vcont2 =90;
#define tdado_msb  Tdado[11],2  //msb
#endif



byte const mens_2[] ={"LARIOS.TECNOL.WS@"};
byte const mens_3[] ={"FIM DO SORTEIO  @"};
byte const mens_4[] ={"NUM.SORT:       @"};
byte const mens_5[] ={"RESTAM:         @"};
byte const mens_6[] ={"INICIAR SORTEIO!@"};
byte const mens_7[] ={"APERTE O BOTAO! @"};
//variavis
int Tdado [13];  // FLAGS DE SORTEADO OU NO
#locate  Tdado = 0x40
int cont1=vcont1;
int cont2=vcont2;
#byte tmr0 =0x01



//==============================================================================
//               SUBROTINAS
//==============================================================================



//==============================================================================
//               CONVERTE DE HEX PARA DECIMAL 0-99
//==============================================================================
int conv_dec(int aux){
    int dez=0;
    while(aux>9){aux-=10; ++dez;}
         swap(dez);
         aux+=dez;
         return aux;
}
//==============================================================================
//        OBTM UM NMERO  PSEUDO_RANDOMICA A PARTIR DO TIMER 0
//==============================================================================

int sorteia(void){

 int mt0,a,st;

    mt0=tmr0;  //timer 0 fornece valor aleatrio
    a=0;
    st= mt0 & 0xFE; //LSB fornece o sentido da rotao
//rotaciona cont1 e Tdado (bits de flag) pelo nmero fornecido pelo timer 0
    while(a!=mt0){
     ++a;
     if(bit_test(Tdado[0],0)){bit_set(tdado_msb);} //tombola tdado[11],2
     else {bit_clear(tdado_msb);}//coloca no bit 4 msb
     shift_right(Tdado,13,0);
     if(++cont1>vcomp){cont1=1; }  //VCOMP= 90 TOMBOLA

     }
//==============================================================================
//             TESTA SE NUMERO J FOI SORTEADO
//==============================================================================
// verifica se nmero j foi sorteado por analisar o bit correspondente
// se j foi, testa  'st' e se=0 roda para esq. ou se=1 roda para direita, em
//busca de um novo nmero
     a=0;

     while ((!bit_test(Tdado[0],0))&& (a<(vcomp+1)))  {
        if(bit_test(Tdado[0],0)){bit_set(tdado_msb);}
        else {bit_clear(tdado_msb);}//coloca no bit 4 msb
        if(st){
            if(bit_test(Tdado[0],0)){bit_set(tdado_msb);}
            else {bit_clear(tdado_msb);}//coloca no bit 4 msb
            shift_right(Tdado,13,0);//roda para direita
            if(++cont1>vcomp){cont1=1;}

        }
        else
        {
           shift_left(Tdado,0,0);//roda para esquerda
           if(bit_test(tdado_msb)){bit_set(tdado_msb);}
           else {bit_clear(Tdado[0],0);}//coloca no bit 4 msb
           if(--cont1==0xff){cont1=vcomp;}

        }
        ++a;
     }
    bit_clear(Tdado[0],0) ;//tica como j sorteado
    return conv_dec(cont1); //converte p/ decimal e retorna
}
//==============================================================================
//              ENVIA BYTE PARA LCD
//==============================================================================
   void env_lcd(int a){
   int b;
    b=a>>4;
   if(b<=9){ b+='0';}
   else { b+='7';}
   lcd_putc(b);
   b=a&0x0f;
   if(b<=9){ b+='0';}
   else { b+='7';}
   lcd_putc(b);
   }


//==============================================================================
//
//               PROGRAMA PRINCIPAL
//
//==============================================================================

void main() {
   int a,val;
   setup_counters(RTCC_INTERNAL,RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);


   lcd_init();//inicializao do lcd
   linha1;//linha 1 do lcd
   for (a=0;(mens_1[a]!='@');a++) lcd_putc(mens_1[a]);//escreve mensagem
   linha2;
   for (a=0;(mens_2[a]!='@');a++) lcd_putc(mens_2[a]);//escreve mensagem
   for (a=0;a<13;++a){ Tdado[a]=0xff;}// coloca 1 em todos os 'bits flags'

   delay_ms(2000);
   limpa_lcd;
   linha1;
   //---------------------------------------------------------------------------

   for (a=0;(mens_6[a]!='@');a++) lcd_putc(mens_6[a]);//escreve 'inciar sort'
   linha2;
   for (a=0;(mens_7[a]!='@');a++) lcd_putc(mens_7[a]);//escreve 'aperte o bot'

   while(TRUE){

      while(input(bot));
      val=sorteia();
      if(--cont2==0){// tombola/bingo=1  s0-99=0
      pos_ap; //posiciona cursor para apresentar o numero sorteado
      env_lcd(val);
      linha2;
      for (a=0;(mens_3[a]!='@');a++) lcd_putc(mens_3[a]);//escreve 'fim sorteio'
      for (a=0;a<13;++a){ Tdado[a]=0xff;}// coloca 1 em todos os bits
      cont1=vcont1;
      cont2=vcont2;
      delay_ms(500);
      while(input(bot));//aguarda aperto do boto
      linha1;
      for (a=0;(mens_6[a]!='@');a++) lcd_putc(mens_6[a]);//escreve 'iniciar sort'
      linha2;
      for (a=0;(mens_7[a]!='@');a++) lcd_putc(mens_7[a]);//escreve 'aperte o bot'
      delay_ms(500);
      }
      else{
      linha1;
      for (a=0;(mens_4[a]!='@');a++) lcd_putc(mens_4[a]);//escreve 'num.sort:'
      pos_ap; //posiciona cursor para apresentar o numero sorteado
      env_lcd(val);
      pos_ns;//posiciona
      for (a=0;(mens_5[a]!='@');a++) lcd_putc(mens_5[a]);//escreve 'restam'
      pos_nf ;//posiciona
      env_lcd(conv_dec(cont2));

      }

   delay_ms(500);

  }//while

}//main






